diff --git a/src/backend/tcop/pquery.c b/src/backend/tcop/pquery.c
index 66cc5c35c68..8b803c77d5b 100644
--- a/src/backend/tcop/pquery.c
+++ b/src/backend/tcop/pquery.c
@@ -1071,7 +1071,7 @@ RunFromStore(Portal portal, ScanDirection direction, uint64 count,
 	uint64		current_tuple_count = 0;
 	TupleTableSlot *slot;
 
-	slot = MakeSingleTupleTableSlot(portal->tupDesc);
+	slot = MakeSingleTupleTableSlot(portal->tupDesc, TTS_TYPE_MINIMALTUPLE);
 
 	dest->rStartup(dest, CMD_SELECT, portal->tupDesc);
 
diff --git a/src/backend/utils/adt/orderedsetaggs.c b/src/backend/utils/adt/orderedsetaggs.c
index 50b34fcbc68..e833ed1f852 100644
--- a/src/backend/utils/adt/orderedsetaggs.c
+++ b/src/backend/utils/adt/orderedsetaggs.c
@@ -240,7 +240,8 @@ ordered_set_startup(FunctionCallInfo fcinfo, bool use_tuples)
 			}
 
 			/* Create slot we'll use to store/retrieve rows */
-			qstate->tupslot = MakeSingleTupleTableSlot(qstate->tupdesc);
+			qstate->tupslot = MakeSingleTupleTableSlot(qstate->tupdesc,
+													   TTS_TYPE_VIRTUAL);
 		}
 		else
 		{
@@ -398,17 +399,17 @@ ordered_set_transition_multi(PG_FUNCTION_ARGS)
 	nargs = PG_NARGS() - 1;
 	for (i = 0; i < nargs; i++)
 	{
-		slot->tts_values[i] = PG_GETARG_DATUM(i + 1);
-		slot->tts_isnull[i] = PG_ARGISNULL(i + 1);
+		slot->values[i] = PG_GETARG_DATUM(i + 1);
+		slot->nulls[i] = PG_ARGISNULL(i + 1);
 	}
 	if (osastate->qstate->aggref->aggkind == AGGKIND_HYPOTHETICAL)
 	{
 		/* Add a zero flag value to mark this row as a normal input row */
-		slot->tts_values[i] = Int32GetDatum(0);
-		slot->tts_isnull[i] = false;
+		slot->values[i] = Int32GetDatum(0);
+		slot->nulls[i] = false;
 		i++;
 	}
-	Assert(i == slot->tts_tupleDescriptor->natts);
+	Assert(i == slot->tupleDescriptor->natts);
 	ExecStoreVirtualTuple(slot);
 
 	/* Load the row into the tuplesort object */
@@ -1200,11 +1201,11 @@ hypothetical_rank_common(FunctionCallInfo fcinfo, int flag,
 	ExecClearTuple(slot);
 	for (i = 0; i < nargs; i++)
 	{
-		slot->tts_values[i] = PG_GETARG_DATUM(i + 1);
-		slot->tts_isnull[i] = PG_ARGISNULL(i + 1);
+		slot->values[i] = PG_GETARG_DATUM(i + 1);
+		slot->nulls[i] = PG_ARGISNULL(i + 1);
 	}
-	slot->tts_values[i] = Int32GetDatum(flag);
-	slot->tts_isnull[i] = false;
+	slot->values[i] = Int32GetDatum(flag);
+	slot->nulls[i] = false;
 	ExecStoreVirtualTuple(slot);
 
 	tuplesort_puttupleslot(osastate->sortstate, slot);
@@ -1353,11 +1354,11 @@ hypothetical_dense_rank_final(PG_FUNCTION_ARGS)
 	ExecClearTuple(slot);
 	for (i = 0; i < nargs; i++)
 	{
-		slot->tts_values[i] = PG_GETARG_DATUM(i + 1);
-		slot->tts_isnull[i] = PG_ARGISNULL(i + 1);
+		slot->values[i] = PG_GETARG_DATUM(i + 1);
+		slot->nulls[i] = PG_ARGISNULL(i + 1);
 	}
-	slot->tts_values[i] = Int32GetDatum(-1);
-	slot->tts_isnull[i] = false;
+	slot->values[i] = Int32GetDatum(-1);
+	slot->nulls[i] = false;
 	ExecStoreVirtualTuple(slot);
 
 	tuplesort_puttupleslot(osastate->sortstate, slot);
@@ -1371,9 +1372,10 @@ hypothetical_dense_rank_final(PG_FUNCTION_ARGS)
 	 * previous row available for comparisons.  This is accomplished by
 	 * swapping the slot pointer variables after each row.
 	 */
-	extraslot = MakeSingleTupleTableSlot(osastate->qstate->tupdesc);
+	extraslot = MakeSingleTupleTableSlot(osastate->qstate->tupdesc,
+										 TTS_TYPE_MINIMALTUPLE);
 	slot2 = extraslot;
-
+	/* FIXME: will store minimal into virtual slot! */
 	/* iterate till we find the hypothetical row */
 	while (tuplesort_gettupleslot(osastate->sortstate, true, true, slot,
 								  &abbrevVal))
diff --git a/src/backend/utils/adt/selfuncs.c b/src/backend/utils/adt/selfuncs.c
index fcc8323f626..69d5622ed07 100644
--- a/src/backend/utils/adt/selfuncs.c
+++ b/src/backend/utils/adt/selfuncs.c
@@ -5504,7 +5504,8 @@ get_actual_variable_range(PlannerInfo *root, VariableStatData *vardata,
 			indexInfo = BuildIndexInfo(indexRel);
 
 			/* some other stuff */
-			slot = MakeSingleTupleTableSlot(RelationGetDescr(heapRel));
+			slot = MakeSingleTupleTableSlot(RelationGetDescr(heapRel),
+											TTS_TYPE_HEAPTUPLE);
 			econtext->ecxt_scantuple = slot;
 			get_typlenbyval(vardata->atttype, &typLen, &typByVal);
 			InitNonVacuumableSnapshot(SnapshotNonVacuumable, RecentGlobalXmin);
diff --git a/src/backend/utils/sort/tuplesort.c b/src/backend/utils/sort/tuplesort.c
index 041bdc2fa7e..ef2669c603b 100644
--- a/src/backend/utils/sort/tuplesort.c
+++ b/src/backend/utils/sort/tuplesort.c
@@ -933,7 +933,7 @@ tuplesort_begin_cluster(TupleDesc tupDesc,
 		 * scantuple has to point to that slot, too.
 		 */
 		state->estate = CreateExecutorState();
-		slot = MakeSingleTupleTableSlot(tupDesc);
+		slot = MakeSingleTupleTableSlot(tupDesc, TTS_TYPE_VIRTUAL);
 		econtext = GetPerTupleExprContext(state->estate);
 		econtext->ecxt_scantuple = slot;
 	}
diff --git a/src/include/access/htup_details.h b/src/include/access/htup_details.h
index 2ab1815390c..5bcdca99601 100644
--- a/src/include/access/htup_details.h
+++ b/src/include/access/htup_details.h
@@ -826,4 +826,9 @@ extern MinimalTuple heap_copy_minimal_tuple(MinimalTuple mtup);
 extern HeapTuple heap_tuple_from_minimal_tuple(MinimalTuple mtup);
 extern MinimalTuple minimal_tuple_from_heap_tuple(HeapTuple htup);
 
+struct TupleTableSlot;
+extern void
+slot_deform_tuple(struct TupleTableSlot *slot, HeapTuple tuple, uint32 *offp, int natts);
+
+
 #endif							/* HTUP_DETAILS_H */
diff --git a/src/include/executor/executor.h b/src/include/executor/executor.h
index 45a077a949c..430e3ec6b27 100644
--- a/src/include/executor/executor.h
+++ b/src/include/executor/executor.h
@@ -342,8 +342,9 @@ ExecProject(ProjectionInfo *projInfo)
 	 * Successfully formed a result row.  Mark the result slot as containing a
 	 * valid virtual tuple (inlined version of ExecStoreVirtualTuple()).
 	 */
-	slot->tts_isempty = false;
-	slot->tts_nvalid = slot->tts_tupleDescriptor->natts;
+	//FIXME: slot->isempty = false;
+	slot->flags &= ~TTS_ISEMPTY;
+	slot->nvalid = slot->tupleDescriptor->natts;
 
 	return slot;
 }
@@ -431,12 +432,12 @@ extern void ExecScanReScan(ScanState *node);
 /*
  * prototypes from functions in execTuples.c
  */
-extern void ExecInitResultTupleSlotTL(EState *estate, PlanState *planstate);
-extern void ExecInitScanTupleSlot(EState *estate, ScanState *scanstate, TupleDesc tupleDesc);
+extern void ExecInitResultTupleSlotTL(EState *estate, PlanState *planstate, TupleTableSlotType st);
+extern void ExecInitScanTupleSlot(EState *estate, ScanState *scanstate, TupleDesc tupleDesc, TupleTableSlotType st);
 extern TupleTableSlot *ExecInitExtraTupleSlot(EState *estate,
-					  TupleDesc tupleDesc);
+					  TupleDesc tupleDesc, TupleTableSlotType st);
 extern TupleTableSlot *ExecInitNullTupleSlot(EState *estate,
-					  TupleDesc tupType);
+					  TupleDesc tupType, TupleTableSlotType st);
 extern TupleDesc ExecTypeFromTL(List *targetList, bool hasoid);
 extern TupleDesc ExecCleanTypeFromTL(List *targetList, bool hasoid);
 extern TupleDesc ExecTypeFromExprList(List *exprList);
@@ -510,7 +511,8 @@ extern void ExecConditionalAssignProjectionInfo(PlanState *planstate,
 									TupleDesc inputDesc, Index varno);
 extern void ExecFreeExprContext(PlanState *planstate);
 extern void ExecAssignScanType(ScanState *scanstate, TupleDesc tupDesc);
-extern void ExecCreateScanSlotFromOuterPlan(EState *estate, ScanState *scanstate);
+extern void ExecCreateScanSlotFromOuterPlan(EState *estate, ScanState *scanstate,
+											TupleTableSlotType tp);
 
 extern bool ExecRelationIsTargetRelation(EState *estate, Index scanrelid);
 
diff --git a/src/include/executor/tuptable.h b/src/include/executor/tuptable.h
index 8be0d5edc29..beeb630a4c1 100644
--- a/src/include/executor/tuptable.h
+++ b/src/include/executor/tuptable.h
@@ -110,42 +110,111 @@
  * be touched by any other code.
  *----------
  */
-typedef struct TupleTableSlot
+
+/* true = slot is empty */
+#define			TTS_ISEMPTY			(1 << 1)
+/* should pfree tts_tuple? */
+#define			TTS_SHOULDFREE		(1 << 2)
+/* should pfree tts_mintuple? */
+#define			TTS_SHOULDFREEMIN	(1 << 3)
+/* saved state for slot_deform_tuple */
+#define			TTS_SLOW			(1 << 4)
+/* fixed tuple descriptor */
+#define			TTS_FIXED			(1 << 5)
+
+
+typedef enum TupleTableSlotType
+{
+	TTS_TYPE_VIRTUAL,
+	TTS_TYPE_HEAPTUPLE,
+	TTS_TYPE_MINIMALTUPLE,
+	TTS_TYPE_BUFFER
+} TupleTableSlotType;
+
+struct TupleTableSlot;
+typedef struct TupleTableSlot TupleTableSlot;
+
+typedef struct TupleTableSlotOps
+{
+	void (*init)(TupleTableSlot *slot);
+	void (*release)(TupleTableSlot *slot);
+
+	void (*clear)(TupleTableSlot *slot);
+
+	void (*getsomeattrs)(TupleTableSlot *slot, int natts);
+
+	void (*materialize)(TupleTableSlot *slot);
+
+	HeapTuple (*get_heap_tuple)(TupleTableSlot *slot);
+	MinimalTuple (*get_minimal_tuple)(TupleTableSlot *slot);
+
+	HeapTuple (*copy_heap_tuple)(TupleTableSlot *slot);
+	MinimalTuple (*copy_minimal_tuple)(TupleTableSlot *slot);
+
+} TupleTableSlotOps;
+
+extern Datum ExecFetchSlotTupleDatum(TupleTableSlot *slot);
+
+extern TupleTableSlot *ExecCopySlot(TupleTableSlot *dstslot,
+			 TupleTableSlot *srcslot);
+
+/* virtual or base type */
+struct TupleTableSlot
 {
 	NodeTag		type;
-	bool		tts_isempty;	/* true = slot is empty */
-	bool		tts_shouldFree; /* should pfree tts_tuple? */
-	bool		tts_shouldFreeMin;	/* should pfree tts_mintuple? */
-	bool		tts_slow;		/* saved state for slot_deform_tuple */
-	HeapTuple	tts_tuple;		/* physical tuple, or NULL if virtual */
-	TupleDesc	tts_tupleDescriptor;	/* slot's tuple descriptor */
-	MemoryContext tts_mcxt;		/* slot itself is in this context */
-	Buffer		tts_buffer;		/* tuple's buffer, or InvalidBuffer */
-	int			tts_nvalid;		/* # of valid values in tts_values */
-	Datum	   *tts_values;		/* current per-attribute values */
-	bool	   *tts_isnull;		/* current per-attribute isnull flags */
-	MinimalTuple tts_mintuple;	/* minimal tuple, or NULL if none */
-	HeapTupleData tts_minhdr;	/* workspace for minimal-tuple-only case */
-	long		tts_off;		/* saved state for slot_deform_tuple */
-	bool		tts_fixedTupleDescriptor; /* descriptor can't be changed */
-} TupleTableSlot;
 
-#define TTS_HAS_PHYSICAL_TUPLE(slot)  \
-	((slot)->tts_tuple != NULL && (slot)->tts_tuple != &((slot)->tts_minhdr))
+	uint16		flags;
+	uint16		nvalid;		/* # of valid values in tts_values */
+
+	const TupleTableSlotOps *const cb;
+
+	TupleDesc	tupleDescriptor;	/* slot's tuple descriptor */
+
+	Datum	   *values;		/* current per-attribute values */
+	bool	   *nulls;		/* current per-attribute null flags */
+
+	/* can we optimize away? */
+	MemoryContext mcxt;		/* slot itself is in this context */
+};
+
+
+typedef struct HeapTupleTableSlot
+{
+	TupleTableSlot base;
+	HeapTuple	tuple;		/* physical tuple */
+	uint32		off;		/* saved state for slot_deform_tuple */
+} HeapTupleTableSlot;
+
+/* heap tuple residing in a buffer */
+typedef struct BufferHeapTupleTableSlot
+{
+	HeapTupleTableSlot base;
+	Buffer		buffer;		/* tuple's buffer, or InvalidBuffer */
+} BufferHeapTupleTableSlot;
+
+typedef struct MinimalTupleTableSlot
+{
+	TupleTableSlot base;
+	HeapTuple	tuple;		/* tuple wrapper */
+	MinimalTuple mintuple;	/* minimal tuple, or NULL if none */
+	HeapTupleData minhdr;	/* workspace for minimal-tuple-only case */
+	uint32		off;		/* saved state for slot_deform_tuple */
+} MinimalTupleTableSlot;
 
 /*
  * TupIsNull -- is a TupleTableSlot empty?
  */
 #define TupIsNull(slot) \
-	((slot) == NULL || (slot)->tts_isempty)
+	((slot) == NULL || (slot)->flags & TTS_ISEMPTY)
 
 /* in executor/execTuples.c */
-extern TupleTableSlot *MakeTupleTableSlot(TupleDesc desc);
-extern TupleTableSlot *ExecAllocTableSlot(List **tupleTable, TupleDesc desc);
+extern TupleTableSlot *MakeTupleTableSlot(TupleDesc desc, TupleTableSlotType st);
+extern TupleTableSlot *ExecAllocTableSlot(List **tupleTable, TupleDesc desc, TupleTableSlotType st);
 extern void ExecResetTupleTable(List *tupleTable, bool shouldFree);
-extern TupleTableSlot *MakeSingleTupleTableSlot(TupleDesc tupdesc);
+extern TupleTableSlot *MakeSingleTupleTableSlot(TupleDesc tupdesc, TupleTableSlotType st);
 extern void ExecDropSingleTupleTableSlot(TupleTableSlot *slot);
 extern void ExecSetSlotDescriptor(TupleTableSlot *slot, TupleDesc tupdesc);
+
 extern TupleTableSlot *ExecStoreTuple(HeapTuple tuple,
 			   TupleTableSlot *slot,
 			   Buffer buffer,
@@ -153,22 +222,95 @@ extern TupleTableSlot *ExecStoreTuple(HeapTuple tuple,
 extern TupleTableSlot *ExecStoreMinimalTuple(MinimalTuple mtup,
 					  TupleTableSlot *slot,
 					  bool shouldFree);
-extern TupleTableSlot *ExecClearTuple(TupleTableSlot *slot);
+
 extern TupleTableSlot *ExecStoreVirtualTuple(TupleTableSlot *slot);
 extern TupleTableSlot *ExecStoreAllNullTuple(TupleTableSlot *slot);
-extern HeapTuple ExecCopySlotTuple(TupleTableSlot *slot);
-extern MinimalTuple ExecCopySlotMinimalTuple(TupleTableSlot *slot);
+
 extern HeapTuple ExecFetchSlotTuple(TupleTableSlot *slot);
 extern MinimalTuple ExecFetchSlotMinimalTuple(TupleTableSlot *slot);
 extern Datum ExecFetchSlotTupleDatum(TupleTableSlot *slot);
-extern HeapTuple ExecMaterializeSlot(TupleTableSlot *slot);
+
 extern TupleTableSlot *ExecCopySlot(TupleTableSlot *dstslot,
 			 TupleTableSlot *srcslot);
 
+
+static inline TupleTableSlot *
+ExecClearTuple(TupleTableSlot *slot)
+{
+	slot->cb->clear(slot);
+	return slot;
+}
+
+static inline HeapTuple
+ExecMaterializeSlot(TupleTableSlot *slot)
+{
+	slot->cb->materialize(slot);
+	return slot->cb->get_heap_tuple(slot);
+}
+
+static inline HeapTuple
+ExecCopySlotTuple(TupleTableSlot *slot)
+{
+	/*
+	 * sanity checks
+	 */
+	Assert(slot != NULL);
+	Assert(!(slot->flags & TTS_ISEMPTY));
+	return slot->cb->copy_heap_tuple(slot);
+}
+
+static inline MinimalTuple
+ExecCopySlotMinimalTuple(TupleTableSlot *slot)
+{
+	return slot->cb->copy_minimal_tuple(slot);
+}
+
 /* in access/common/heaptuple.c */
-extern Datum slot_getattr(TupleTableSlot *slot, int attnum, bool *isnull);
-extern void slot_getallattrs(TupleTableSlot *slot);
-extern void slot_getsomeattrs(TupleTableSlot *slot, int attnum);
-extern bool slot_attisnull(TupleTableSlot *slot, int attnum);
+
+static inline Datum
+slot_getattr(TupleTableSlot *slot, int attnum, bool *isnull)
+{
+	Assert(attnum > 0);
+
+	if (attnum > slot->nvalid)
+		slot->cb->getsomeattrs(slot, attnum);
+
+	Assert(attnum <= slot->nvalid);
+
+	*isnull = slot->nulls[attnum - 1];
+	return slot->values[attnum - 1];
+}
+
+static inline void
+slot_getallattrs(TupleTableSlot *slot)
+{
+	int			tdesc_natts = slot->tupleDescriptor->natts;
+
+	/* Quick out if we have 'em all already */
+	if (slot->nvalid == tdesc_natts)
+		return;
+	slot->cb->getsomeattrs(slot, tdesc_natts);
+}
+
+
+static inline void
+slot_getsomeattrs(TupleTableSlot *slot, int attnum)
+{
+	/* FIXME: we're sometimes called with attnum == 0 which is wrong */
+	Assert(attnum >= 0);
+
+	if (attnum > slot->nvalid)
+		slot->cb->getsomeattrs(slot, attnum);
+}
+
+static inline bool
+slot_attisnull(TupleTableSlot *slot, int attnum)
+{
+	bool isnull;
+
+	slot_getattr(slot, attnum, &isnull);
+
+	return isnull;
+}
 
 #endif							/* TUPTABLE_H */
diff --git a/src/include/nodes/execnodes.h b/src/include/nodes/execnodes.h
index a953820f43a..d7c54057ae5 100644
--- a/src/include/nodes/execnodes.h
+++ b/src/include/nodes/execnodes.h
@@ -992,6 +992,9 @@ typedef struct ModifyTableState
 	OnConflictAction mt_onconflict; /* ON CONFLICT type */
 	List	   *mt_arbiterindexes;	/* unique index OIDs to arbitrate taking
 									 * alt path */
+
+	TupleTableSlot *mt_scan;	/* input */
+
 	TupleTableSlot *mt_existing;	/* slot to store existing target tuple in */
 	List	   *mt_excludedtlist;	/* the excluded pseudo relation's tlist  */
 	TupleTableSlot *mt_conflproj;	/* CONFLICT ... SET ... projection target */
-- 
2.15.1.354.g95ec6b1b33.dirty

